#include <WiFi.h>
#include <PubSubClient.h>

WiFiClient client;
PubSubClient mqtt_client(client);

//請修改以下參數
//-------------------------------------------------------------------------------------------
char  szSSID[] = "Your_WiFi_AP_SSID";         //Your_SSID
char  szPassword[] = "Your_WiFi_AP_Password"; //Your_Password
char  szMQTTBroker[] = "Your.MQTT.Broker";    //Your_MQTT_Broker
int   nMQTTBrokerPort = 1883;
char  szMQTTClientID[] = "Your_MQTT_Client_ID";         //Unique_MQTT_Client_ID
char  szMQTTSubscribeTopic[] = "Unique_BlueLED_Topic";  //Your_BlueLED_Topic
//-------------------------------------------------------------------------------------------

void fnWiFiConnect()
{
    //連線到指定的WiFi szSSID
    Serial.print("Connecting Wifi: ");
    Serial.println(szSSID);
    
    while (WiFi.status() != WL_CONNECTED) { 
        Serial.print("."); 
        delay(300);
    };
    digitalWrite(3, LOW); 
    //連線成功，顯示取得的IP
    Serial.println("\nWiFi Connected!");
    Serial.print("IP address: ");
    IPAddress ip = WiFi.localIP();
    Serial.println(ip);
}

void fnMQTTConnectCheck() 
{
    while (!mqtt_client.connected()) 
    {
        bool bConnected=false;

        Serial.print(".");
        
        if (bConnected) {   
            
            Serial.println("\nMQTT Broker Connected!");
        }
    }
}

void setup() 
{
    Serial.begin(115200);
    pinMode(3, OUTPUT);
    pinMode(9, OUTPUT); 
    digitalWrite(3, HIGH); 
    digitalWrite(9, HIGH); 
    
    fnWiFiConnect();
    mqtt_client.setCallback(callback);
    
    fnMQTTConnectCheck();
}

void loop() 
{
    fnMQTTConnectCheck();
    mqtt_client.loop();
}

String fnGetMQTTData(String szSubscribeTopic, String szGetTopic, byte* pGetPayload, unsigned int nGetLens)
{
    String szMQTTPayload="";

    if(szGetTopic == szSubscribeTopic){
        for (int i = 0; i < nGetLens; i++) {
            szMQTTPayload += (char)pGetPayload[i];
        }
        return szMQTTPayload;
    }else{
        return "";
    }
}

void callback(char* szGetTopic, byte* pGetPayload, unsigned int nGetLens)
{
    Serial.println((fnGetMQTTData(szMQTTSubscribeTopic, szGetTopic, pGetPayload, nGetLens)));
    if (fnGetMQTTData(szMQTTSubscribeTopic, szGetTopic, pGetPayload, nGetLens) == "ON") {
        digitalWrite(9, LOW);
    } 
    else if (fnGetMQTTData(szMQTTSubscribeTopic, szGetTopic, pGetPayload, nGetLens) == "OFF") {
        digitalWrite(9, HIGH);
    }
}
