#include <WiFi.h>
#include <WiFiUdp.h>

//請修改以下參數
//-------------------------------------------------------------------------------------------
char    szSSID[] = "Your_WiFi_AP_SSID";         //Your_SSID
char    szPassword[] = "Your_WiFi_AP_Password"; //Your_Password
String  szLINEToken = "Your_LINE_Notify_Token"; //Your_LINE_Notify_Token
//-------------------------------------------------------------------------------------------

WiFiSSLClient client;

float fnUltraSonicDistance(int nTrigPin, int nEchoPin) 
{
    digitalWrite(nTrigPin, LOW);
    digitalWrite(nEchoPin, LOW);
    delayMicroseconds(5);
    digitalWrite(nTrigPin, HIGH);
    delayMicroseconds(10);
    digitalWrite(nTrigPin, LOW);
    unsigned long sonic_duration = pulseIn(nEchoPin, HIGH);
    float fDistanceCM = (sonic_duration / 2.0) / 29.1;
    return fDistanceCM;
}

void fnWiFiConnect()
{
    //連線到指定的WiFi szSSID
    Serial.print("Connecting Wifi: ");
    Serial.println(szSSID);
    WiFi.begin(szSSID, szPassword);
    while (WiFi.status() != WL_CONNECTED) { 
        Serial.print("."); 
        delay(300);
    };
    //連線成功，顯示取得的IP
    digitalWrite(3, LOW); 
    Serial.println("\nWiFi Connected!");
    Serial.print("IP address: ");
    IPAddress ip = WiFi.localIP();
    Serial.println(ip);
}

void setup() 
{
    Serial.begin(115200);
    
    pinMode(3, OUTPUT);
    pinMode(9, OUTPUT);
    pinMode(11,OUTPUT);
    pinMode(12,INPUT);
    digitalWrite(3, HIGH); 
    digitalWrite(9, HIGH); 
    
    fnWiFiConnect();
}

void loop() 
{
    if(WiFi.status() != WL_CONNECTED)
        fnWiFiConnect();

    float  fDistance=fnUltraSonicDistance(11, 12);
    //Serial.println(fDistance);
    if(fDistance > 0 && fDistance < 20)
    {
        digitalWrite(3, HIGH);
        fnSendLINEMsg("注意! 有人入侵!!", szLINEToken);
        delay(3000);
        digitalWrite(3, LOW);
    }
}

String URLEncode(const char* msg)
{
    const char *hex = "0123456789abcdef";
    String encodedMsg = "";
    while (*msg!='\0'){
        if(('a' <= *msg && *msg <= 'z')||('A' <= *msg && *msg <= 'Z')||('0' <= *msg && *msg <= '9')){
            encodedMsg += *msg;
        }else{
            encodedMsg += '%';
            encodedMsg += hex[*msg >> 4];
            encodedMsg += hex[*msg & 15];
        }
        msg++;
    }
    return encodedMsg;
}

void fnSendLINEMsg(String szLINEMsg, String szToken)
{
    WiFiSSLClient clientSecure;

    //if () {
        String data = "message="+URLEncode(szLINEMsg.c_str());
        
        clientSecure.println("POST /api/notify HTTP/1.1");
        clientSecure.println("Host: notify-api.line.me");
        clientSecure.println("Authorization: Bearer "+ szToken);
        clientSecure.println("Content-Type: application/x-www-form-urlencoded");
        clientSecure.print("Content-Length: ");
        clientSecure.println(data.length());
        clientSecure.println();
        clientSecure.println(data);
        clientSecure.stop();
    //}
}